﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Windows.Forms;
using System.IO;

namespace Lab2 {
    public partial class Form1 : Form {
        private List<List<string>> table;
        private string alphabet;
        private string subchain;

        private List<string> f;
        private List<string> q;
        private List<string> v;

        public Form1()
        {
            InitializeComponent();
        }

        //Цепочка
        Form2 func = null;
        Form3 configs = new Form3();
        private void checkChainButton_Click(object sender, EventArgs e)
        {

            //Проверяем заполненность полей
            if (VTextBox.Text.Length == 0)
            {
                MessageBox.Show("Не задан алфавит языка.", "Ошибка", MessageBoxButtons.OK, MessageBoxIcon.Error);
                VTextBox.Focus();
                return;
            }
            alphabet = string.Join("", (new List<string>(VTextBox.Text.Split(new char[] { ',', ' ' }, StringSplitOptions.RemoveEmptyEntries))).ToArray());
            subchain = subchainTextBox.Text;
            v = new List<string>();
            foreach(char ch in alphabet)
                v.Add(ch.ToString());

            //Проверяем наличие в конечной подцепочке символов, не принадлежащих языку
            foreach(char ch in subchain)
                if (!v.Contains(ch.ToString()))
                {
                    MessageBox.Show("Конечная подцепочка содержит символы, не принадлежащие языку.", "Ошибка", MessageBoxButtons.OK, MessageBoxIcon.Error);
                    subchainTextBox.Focus();
                    return;
                }
            //Проверяем наличие в цепочке символов, не принадлежащих языку
            foreach (char ch in chainTextBox.Text)
                if (!v.Contains(ch.ToString()))
                {
                    MessageBox.Show("Цепочка содержит символы, не принадлежащие языку.", "Ошибка", MessageBoxButtons.OK, MessageBoxIcon.Error);
                    chainTextBox.Focus();
                    return;
                }

            //Строим ДКА
            buldDKA();

            //Заполняем таблицу переходов
            if(func!=null)
                func.Dispose();
            func = new Form2(table);
            func.Show();
            
            configs.Dispose();
            configs = new Form3();
            configs.Show();
            
            configs.configsLB.AppendText("Построенный ДКА: M(Q,{" + string.Join(",", v) + "},S," + q[0] +",F)");
            configs.configsLB.AppendText("\nQ = {" + string.Join(",", q) + "}, F = {" + string.Join(",", f) + "}");
        }


        //Построение ДКА
        private void buldDKA()
        {
            table = new List<List<string>>();

            //Построение таблицы
            List<string> v1 = new List<string>();
            v1.Add("");
            for(int i=0; i<alphabet.Length; i++)
                v1.Add(alphabet[i].ToString());
            table.Add(v1);
            v1 = new List<string>();

            for(int i=0; i<=subchain.Length; i++) {
                v1.Add("q"+i.ToString());
                for(int j=0; j<alphabet.Length; j++)
                    v1.Add("");
                table.Add(v1);
                v1 = new List<string>();
            }

            //Заполняем первую строчку
            for(int i=1; i<=alphabet.Length; i++)
                table[1][i] += "q0";

            //Заполняем таблицу
            for(int i=1; i<table.Count-1; i++) {
                for(int j=1; j<=alphabet.Length; j++) {
                    if(subchain[i-1].ToString() == table[0][j]) {
                        table[i][j] += " q"+i.ToString();
                        table[i][j] = table[i][j].Trim();
                    }
                }
            }

            for(int i=1; i<table.Count; i++) {
                for(int j=1; j<=alphabet.Length; j++) {
                    bool condFound = false;
                    string cond = table[i][j]; //Условие для поиска
                    if(string.IsNullOrEmpty(cond))
                        break;
                    for(int k=1; k<table.Count; k++) {
                        if(table[k][0] == cond) {
                            condFound = true;
                            break;
                        }
                    }
                    if(!condFound) {
                        v1.Add(cond);
                        for(int k=1; k<=alphabet.Length; k++)
                            v1.Add(getCond(new List<string>(cond.Split(new char[]{' '}, StringSplitOptions.RemoveEmptyEntries)), k));
                        table.Add(v1);
                        v1 = new List<string>();
                    }
                }
            }

            //Убираем недостижимые состояние
            for(int i=1; i<table.Count; i++)
                for(int j=1; j<=alphabet.Length; j++)
                    if(string.IsNullOrEmpty(table[i][j])) {
                        table.RemoveAt(i);
                        --i;
                        break;
                    }

            //Находим конечное состояние
            string f_state = "q" + subchain.Length.ToString();
            getFinalStates(f_state);

            //Приводим таблицу к более удобочитаемому виду
            int letter = 65;
            bool changed = false;
            for(int i=1; i<table.Count; i++) {
                for(int j=1; j<=alphabet.Length; j++) {
                    if(table[i][j].Contains(' ')) {
                        string srch = table[i][j];
                        for(int m=1; m<table.Count; m++) {
                            for(int n=0; n<=alphabet.Length; n++) {
                                if(table[m][n] == srch) {
                                    table[m][n] = ((char)letter).ToString();
                                    changed = true;
                                }
                            }
                        }
                        for(int z=0; z<f.Count; z++)
                            if(f[z] == srch)
                                f[z] = ((char)letter).ToString();
                        if(changed) {
                            letter++;
                            changed = false;
                        }
                    }
                }
            }

            //Находим множество состояний
            q = new List<string>();
            for (int i = 1; i < table.Count; i++)
                for (int j = 0; j <= alphabet.Length; j++)
                    if (!q.Contains(table[i][j]))
                        q.Add(table[i][j]);
        }

        private string getCond(List<string> lst, int k)
        {
            List<string> condition = new List<string>();
            while(lst.Any()) { //Is list empty
                string c = lst[0];
                lst.RemoveAt(0);
                for(int i=1; i<table.Count; i++)
                    if(c == table[i][0]) {
                        condition.Add(table[i][k]);
                        break;
                    }
            }
            return string.Join(" ", condition).Trim();
        }

        private void getFinalStates(string f_state)
        {
            f = new List<string>();
            for(int i=1; i<table.Count; i++)
                for(int j=1; j<=alphabet.Length; j++)
                    if(table[i][j].Contains(f_state) && !f.Contains(table[i][j]))
                        f.Add(table[i][j]);
        }

        private void button1_Click(object sender, EventArgs e)
        {
            if(func == null) {
                MessageBox.Show("ДКА не построен.", "Ошибка", MessageBoxButtons.OK, MessageBoxIcon.Error);
                return;
            }
            configs.Show();
            configs.configsLB.AppendText("\n\nПроверка цепочки " + chainTextBox.Text + ":\n");

            bool flag = false;
            string chTmp = " ";

            //Проверка пустой цепочки на принадлежность языку
            if (chainTextBox.Text == "")
            {
                foreach (string ch in f)
                {
                    if (ch == q[0])
                    {
                        flag = true;
                        configs.configsLB.AppendText("\nЦепочка принадлежит языку.");
                    }
                }
                if (!flag)
                    configs.configsLB.AppendText("\nЦепочка не принадлежит языку. Не достигнуто конечное состояние.");
            }
            //Проверка непустой цепочки на принадлежность языку
            else
            {
                int i = 0;
                int tb = 1;

                configs.configsLB.AppendText("(" + q[0] + ", " + chainTextBox.Text + ")");

                //Ищем символы, отсутствующие в языке
                for (i = 0; i < chainTextBox.Text.Length; ++i)
                {
                    if (!v.Contains(chainTextBox.Text[i].ToString()))
                    {
                        flag = true;
                        break;
                    }

                    for (int j = 0; j < v.Count; ++j)
                    {
                        if (Form2.transitionFunTable[0, j + 1] == chainTextBox.Text[i].ToString())
                        {
                            chTmp = Form2.transitionFunTable[tb, j + 1];
                            break;
                        }
                    }

                    for (int j = 0; j < q.Count; ++j)
                    {
                        if (Form2.transitionFunTable[j + 1, 0] == chTmp)
                        {
                            tb = j + 1;
                            break;
                        }
                        else
                            tb = -1;
                    }

                    if (tb == -1)
                        break;
                    configs.configsLB.AppendText(" |-- (" + chTmp + ", " + chainTextBox.Text.Substring(i + 1, chainTextBox.Text.Length - i - 1) + ")");
                    configs.Refresh();
                }

                if (flag)
                    configs.configsLB.AppendText("\nЦепочка не принадлежит языку. В цепочке присутствуют посторонние символы.");
                else
                {
                    for (int j = 0; j < f.Count; ++j)
                        if (chTmp == f[j])
                            flag = true;

                    if (i == chainTextBox.Text.Length && flag)
                        configs.configsLB.AppendText("\nЦепочка принадлежит языку.");
                    else if (i == chainTextBox.Text.Length && !flag)
                        configs.configsLB.AppendText("\nЦепочка не принадлежит языку.Не достигнуто конечное состояние.");
                    else if (i != chainTextBox.Text.Length && flag)
                        configs.configsLB.AppendText("\nЦепочка не принадлежит языку. Не все символы цепочки были прочитаны.");
                    else if (i != chainTextBox.Text.Length && !flag)
                        configs.configsLB.AppendText("\nЦепочка не принадлежит языку. Нарушены правила.");
                }
            }
        }

        private void авторToolStripMenuItem_Click(object sender, EventArgs e)
        {
            MessageBox.Show("Студент группы ПБВ-22 Топчиёва Т.В.", "Автор программы", MessageBoxButtons.OK, MessageBoxIcon.Information);
        }

        private void темаToolStripMenuItem_Click(object sender, EventArgs e)
        {
            MessageBox.Show("Автоматическое построение Детерминированного Конечного Автомата", "Тема курсовой работы", MessageBoxButtons.OK, MessageBoxIcon.Information);
        }

        private void данныеToolStripMenuItem_Click(object sender, EventArgs e)
        {
            OpenFileDialog openFileDialog1 = new OpenFileDialog();
            openFileDialog1.InitialDirectory = Application.StartupPath;
            if (openFileDialog1.ShowDialog() != DialogResult.OK)
                return;
            string fname = openFileDialog1.FileName;
            StreamReader sr = new StreamReader(fname);
            string l = sr.ReadLine();
            VTextBox.Text = l;
            l = sr.ReadLine();
            subchainTextBox.Text = l;
            l = sr.ReadLine();
            chainTextBox.Text = l;
            l = sr.ReadLine();
            sr.Close();
            openFileDialog1.Dispose();
        }

        private void записатьРезультатыВФайлToolStripMenuItem_Click(object sender, EventArgs e)
        {
            if(func == null) {
                MessageBox.Show("ДКА не построен.", "Ошибка", MessageBoxButtons.OK, MessageBoxIcon.Error);
                return;
            }
            SaveFileDialog saveFileDialog = new SaveFileDialog();
            saveFileDialog.InitialDirectory = Application.StartupPath;
            saveFileDialog.Filter = "Текстовые файлы (*.txt)|*.txt|Все файлы (*.*)|*.*";
            if (saveFileDialog.ShowDialog() != DialogResult.OK)
                return;
            string fname = saveFileDialog.FileName;
            StreamWriter sw = new StreamWriter(fname);
            sw.WriteLine(configs.configsLB.Text);
            sw.WriteLine("\n");
            for (int i = 0; i < 80; i++)
                sw.Write('-');
            sw.WriteLine("\n");
            sw.WriteLine("Функция переходов:\n");
            for(int i = 0; i < table.Count; i++) {
                for (int j = 0; j <= alphabet.Length; j++)
                    sw.Write(table[i][j] + "\t");
                sw.WriteLine();
            }
            sw.Close();
            saveFileDialog.Dispose();
        }
    }
}
